diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/entry-armv.S linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/entry-armv.S
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/entry-armv.S	2004-08-03 19:25:38.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/entry-armv.S	2005-08-12 15:41:58.000000000 -0600
@@ -4,6 +4,13 @@
  *  Copyright (C) 1996,1997,1998 Russell King.
  *  ARM700 fix by Matthew Godbolt (linux-user@willothewisp.demon.co.uk)
  *
+ *  Copyright (C) 2004-2005 Michael Neuhauser, Firmix Software GmbH (mike@firmix.at)
+ *  	Adeos support for EP93xx
+ *
+ *  Copyright (C) 2005 Adriano Bess (awbess@gmail.com)
+ *                     Ronald Gomes (ronaldfloripa@ig.com.br),
+ *                     Automatisa Sistemas
+ *     Small fixes on Adeos for TS7200 board
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation.
@@ -16,7 +23,6 @@
 #include <linux/config.h>
 #include "entry-header.S"
 
-
 #ifdef IOC_BASE
 /* IOC / IOMD based hardware */
 #include <asm/hardware/iomd.h>
@@ -459,6 +465,9 @@ ENTRY(soft_irq_mask)
                 .macro  disable_fiq
                 .endm
 
+		@ get number of irq from PIC
+		@ is irq <=> Z flag is 0 (ne), number of interrupt to be
+		@ handled is in \irqnr
 // Exit:        irqnr   Highest priority IRQ currently active
 //              flags   NE      irqnr valid
 //                      EQ      irqnr not valid (spurious IRQ)
@@ -662,6 +671,9 @@ ENTRY(anakin_active_irqs)
 /*
  * Invalid mode handlers
  */
+#ifdef CONFIG_ADEOS_CORE
+/* No need to change anything here, kernel will panic anyhow. */
+#endif
 __pabt_invalid:	sub	sp, sp, #S_FRAME_SIZE		@ Allocate frame size in one go
 		stmia	sp, {r0 - lr}			@ Save XXX r0 - lr
 		ldr	r4, .LCabt
@@ -711,12 +723,27 @@ __dabt_svc:	sub	sp, sp, #S_FRAME_SIZE
 		ldr	r2, .LCabt
 		add	r0, sp, #S_FRAME_SIZE
 		ldmia	r2, {r2 - r4}			@ get pc, cpsr
+#ifdef CONFIG_ADEOS_CORE
+		@ Earliest point we can enable hw-interrupts because of values
+		@ saved in __temp_abt (i.e. disabled irqs guards against values
+		@ being changed).
+		@ No other domain than root should generate this
+		@ exception => it is OK to enable irqs.
+@ *TODO* check if root domain? (call __adeos_handle_event(SIGxxx)?)
+		@ There is no need to restore root's stall state (as it is not
+		@ changed by the exception).
+		enable_irq ip
+#endif /* CONFIG_ADEOS_CORE */
 		add	r5, sp, #S_SP
 		mov	r1, lr
 		stmia	r5, {r0 - r4}			@ save sp_SVC, lr_SVC, pc, cpsr, old_ro
+#ifdef CONFIG_ADEOS_CORE
+		@ Interrupts are alredy enabled.
+#else /* !CONFIG_ADEOS_CORE */
 		mrs	r9, cpsr			@ Enable interrupts if they were
 		tst	r3, #I_BIT
 		biceq	r9, r9, #I_BIT			@ previously
+#endif /* CONFIG_ADEOS_CORE */
 /*
  * This routine must not corrupt r9
  */
@@ -727,11 +754,14 @@ __dabt_svc:	sub	sp, sp, #S_FRAME_SIZE
 #else
 		bl	cpu_data_abort
 #endif
+#ifdef CONFIG_ADEOS_CORE
+		@ cpu_data_abort does not change hw-irqs, no need to reenable them.
+#else /* !CONFIG_ADEOS_CORE */
 		msr	cpsr_c, r9
+#endif /* !CONFIG_ADEOS_CORE */
 		mov	r2, sp
 		bl	SYMBOL_NAME(do_DataAbort)
-		mov	r0, #I_BIT | MODE_SVC
-		msr	cpsr_c, r0
+		disable_irq r0				@ disable interrupt hard
 		ldr	r0, [sp, #S_PSR]
 		msr	spsr, r0
 		ldmia	sp, {r0 - pc}^			@ load r0 - pc, cpsr
@@ -751,7 +781,11 @@ __irq_svc:	sub	sp, sp, #S_FRAME_SIZE
 		@ routine called with r0 = irq number, r1 = struct pt_regs *
 		@
 		adrsvc	ne, lr, 1b
+#ifdef CONFIG_ADEOS_CORE
+		ldrne	pc, adeos_irq_entry		@ ...(r0 = irq number, r1 = struct pt_regs *)
+#else /* !CONFIG_ADEOS_CORE */
 		bne	asm_do_IRQ
+#endif /*CONFIG_ADEOS_CORE */
 		ldr	r0, [sp, #S_PSR]		@ irqs are already disabled
 		msr	spsr, r0
 		ldmia	sp, {r0 - pc}^			@ load r0 - pc, cpsr
@@ -764,6 +798,17 @@ __und_svc:	sub	sp, sp, #S_FRAME_SIZE
 		ldr	r7, .LCund
 		mov	r6, lr
 		ldmia	r7, {r7 - r9}
+#ifdef CONFIG_ADEOS_CORE
+		@ Earliest point we can enable hw-interrupts because of values
+		@ saved in __temp_und (i.e. disabled irqs guards against values
+		@ being changed).
+		@ No other domain than root should generate this
+		@ exception => it is OK to enable irqs.
+@ *TODO* check if root domain? (call __adeos_handle_event(SIGxxx)?)
+		@ There is no need to restore root's stall state (as it is not
+		@ changed by the exception).
+		enable_irq ip
+#endif /* CONFIG_ADEOS_CORE */
 		add	r5, sp, #S_FRAME_SIZE
 		add	r4, sp, #S_SP
 		stmia	r4, {r5 - r9}			@ save sp_SVC, lr_SVC, pc, cpsr, old_ro
@@ -771,12 +816,21 @@ __und_svc:	sub	sp, sp, #S_FRAME_SIZE
 		adrsvc	al, r9, 1f			@ r9  = normal FP return
 		bl	call_fpe			@ lr  = undefined instr return
 
+#ifdef CONFIG_ADEOS_CORE
+		@ undefined instruction -> inform Adeos about it (this is *not* the
+		@ "FPU usage" event because there is no FPU support in Adeos for ARM)
+		mov	r0, #4				@ SIGILL
+		mov	r1, sp				@ struct pt_regs *regs
+		bl	__adeos_handle_event
+		cmp	r0, #0
+		bne	1f				@ !propagate -> return
+#endif /* CONFIG_ADEOS_CORE */
+
 		mov	r0, r5				@ unsigned long pc
 		mov	r1, sp				@ struct pt_regs *regs
 		bl	SYMBOL_NAME(do_undefinstr)
 
-1:		mov	r0, #I_BIT | MODE_SVC
-		msr	cpsr_c, r0
+1:		disable_irq r0
 		ldr	lr, [sp, #S_PSR]		@ Get SVC cpsr
 		msr	spsr, lr
 		ldmia	sp, {r0 - pc}^			@ Restore SVC registers
@@ -787,18 +841,32 @@ __pabt_svc:	sub	sp, sp, #S_FRAME_SIZE
 		ldr	r2, .LCabt
 		add	r0, sp, #S_FRAME_SIZE
 		ldmia	r2, {r2 - r4}			@ get pc, cpsr
+#ifdef CONFIG_ADEOS_CORE
+		@ Earliest point we can enable hw-interrupts because of values
+		@ saved in __temp_abt (i.e. disabled irqs guards against values
+		@ being changed).
+		@ No other domain than root should generate this
+		@ exception => it is OK to enable irqs.
+@ *TODO* check if root domain? (call __adeos_handle_event(SIGxxx)?)
+		@ There is no need to restore root's stall state (as it is not
+		@ changed by the exception).
+		enable_irq ip
+#endif /* CONFIG_ADEOS_CORE */
 		add	r5, sp, #S_SP
 		mov	r1, lr
 		stmia	r5, {r0 - r4}			@ save sp_SVC, lr_SVC, pc, cpsr, old_ro
+#ifdef CONFIG_ADEOS_CORE
+		@ Interrupts are already enabled.
+#else /* !CONFIG_ADEOS_CORE */
 		mrs	r9, cpsr			@ Enable interrupts if they were
 		tst	r3, #I_BIT
 		biceq	r9, r9, #I_BIT			@ previously
 		msr	cpsr_c, r9
+#endif /* CONFIG_ADEOS_CORE */
 		mov	r0, r2				@ address (pc)
 		mov	r1, sp				@ regs
 		bl	SYMBOL_NAME(do_PrefetchAbort)	@ call abort handler
-		mov	r0, #I_BIT | MODE_SVC
-		msr	cpsr_c, r0
+		disable_irq r0
 		ldr	r0, [sp, #S_PSR]
 		msr	spsr, r0
 		ldmia	sp, {r0 - pc}^			@ load r0 - pc, cpsr
@@ -811,7 +879,12 @@ __pabt_svc:	sub	sp, sp, #S_FRAME_SIZE
 .LCprocfns:	.word	SYMBOL_NAME(processor)
 #endif
 .LCfp:		.word	SYMBOL_NAME(fp_enter)
-
+#ifdef CONFIG_ADEOS_CORE
+		@ Hook for RTAI immediate irq dispatching.
+		.globl SYMBOL_NAME(adeos_irq_entry)
+SYMBOL_NAME(adeos_irq_entry):
+		.word	SYMBOL_NAME(__adeos_handle_irq)	@ Adeos default irq handler
+#endif /* CONFIG_ADEOS_CORE */
 		irq_prio_table
 
 /*
@@ -825,6 +898,20 @@ __dabt_usr:	sub	sp, sp, #S_FRAME_SIZE		@
 		ldmia	r7, {r2 - r4}			@ Get USR pc, cpsr
 		stmia	r5, {r2 - r4}			@ Save USR pc, cpsr, old_r0
 		stmdb	r5, {sp, lr}^
+#ifdef CONFIG_ADEOS_CORE
+		@ Earliest point we can enable hw-interrupts because of
+		@ "stmdb ...,{ }^" (it stores the user registers which are
+		@ protected by the disabled irqs).
+		enable_irq ip
+		mov	r5, r1				@ save registers
+		mov	r6, r2
+		mov	r4, r3
+		mov	r0, sp				@ regs (arg for func.)
+		bl	SYMBOL_NAME(__adeos_user_exception_save_root)
+		mov	r3, r4				@ restore registers
+		mov	r2, r6
+		mov	r1, r5
+#endif
 		alignment_trap r7, r7, __temp_abt
 		zero_fp
 #ifdef MULTI_CPU
@@ -834,8 +921,11 @@ __dabt_usr:	sub	sp, sp, #S_FRAME_SIZE		@
 #else
 		bl	cpu_data_abort
 #endif
-		mov	r2, #MODE_SVC
-		msr	cpsr_c, r2			@ Enable interrupts
+#ifdef CONFIG_ADEOS_CORE
+		@ Interrupts are already enabled.
+#else /* !CONFIG_ADEOS_CORE */
+		enable_irq r2				@ Enable interrupts
+#endif /* CONFIG_ADEOS_CORE */
 		mov	r2, sp
 		adrsvc	al, lr, ret_from_exception
 		b	SYMBOL_NAME(do_DataAbort)
@@ -851,15 +941,46 @@ __irq_usr:	sub	sp, sp, #S_FRAME_SIZE
 		alignment_trap r4, r7, __temp_irq
 		zero_fp
 1:		get_irqnr_and_base r0, r6, r5, lr
+#ifdef CONFIG_ADEOS_CORE
+		beq	2f				@ no irq -> fast return
+		/* assert(was-irq) */
+		mov	r1, sp
+		mov	lr, pc
+		ldr	pc, adeos_irq_entry		@ ...(r0 = irq number, r1 = struct pt_regs *)
+		@ Adeos irq handler returns with hw-irqs disabled.
+		teq	r0, #0				@ r0 = return code of adeos_irq_entry()
+		/* r0 == 0 <=> irq did not happen in Linux context OR root-ipipe is stalled
+		 *	do a fast return to user-mode to avoid schedule etc.
+		 *	(either context is not right or interrupt would never
+		 *	have happened without Adeos (so Linux doesn't expect
+		 *	schedule etc.))
+		 * r0 != 0 <=> irq did happen in Linux context and root-ipipe is not stalled
+		 *	"normal" interrupt in Linux context, do like original
+		 *	code and return to user-mode via ret_to_user
+		 */
+		bne 3f
+2:		/* assert(!was-irq || !in-linux-context || root-ipipe-is-stalled) */
+		restore_user_regs
+3:		/* assert(was-irq && in-linux-context && !root-ipipe-is-stalled) */
+		@ We have to fix-up the interrupt flag in the saved CPSR
+		@ so that ret_to_user restores the stall state correctly.
+		enable_irq ip				@ do it with hw-irqs enabled
+		mov	r0, sp
+		bl	SYMBOL_NAME(__adeos_user_exception_save_root)
+		mov	why, #0				@ hw-irqs are still enabled
+		get_current_task tsk
+		b	ret_to_user
+#else /* !CONFIG_ADEOS_CORE */
 		movne	r1, sp
 		adrsvc	ne, lr, 1b
 		@
 		@ routine called with r0 = irq number, r1 = struct pt_regs *
 		@
 		bne	asm_do_IRQ
-		mov	why, #0
+		mov	why, #0				@ we come here with interrupts already disabled
 		get_current_task tsk
 		b	ret_to_user
+#endif /* CONFIG_ADEOS_CORE */
 
 		.ltorg
 
@@ -871,6 +992,14 @@ __und_usr:	sub	sp, sp, #S_FRAME_SIZE		@ 
 		ldmia	r4, {r5 - r7}
 		stmia	r8, {r5 - r7}			@ Save USR pc, cpsr, old_r0
 		stmdb	r8, {sp, lr}^			@ Save user sp, lr
+#ifdef CONFIG_ADEOS_CORE
+		@ Earliest point we can enable hw-interrupts because of
+		@ "stmdb ...,{ }^" (it stores the user registers which are
+		@ protected by the disabled irqs).
+		enable_irq ip
+		mov	r0, sp				@ regs (arg for func.)
+		bl	SYMBOL_NAME(__adeos_user_exception_save_root)
+#endif /* CONFIG_ADEOS_CORE */
 		alignment_trap r4, r7, __temp_und
 		zero_fp
 		tst	r6, #T_BIT			@ Thumb mode
@@ -878,17 +1007,27 @@ __und_usr:	sub	sp, sp, #S_FRAME_SIZE		@ 
 		adrsvc	al, r9, ret_from_exception	@ r9  = normal FP return
 		adrsvc	al, lr, fpundefinstr		@ lr  = undefined instr return
 
-call_fpe:	enable_irq r10
-		get_current_task r10
+call_fpe:	get_current_task r10
 		mov	r8, #1
 		strb	r8, [r10, #TSK_USED_MATH]	@ set current->used_math
 		ldr	r4, .LCfp
 		add	r10, r10, #TSS_FPESAVE		@ r10 = workspace
 		ldr	pc, [r4]			@ Call FP module USR entry point
 
-fpundefinstr:	mov	r0, #MODE_SVC
-		msr	cpsr_c, r0			@ Enable interrupts
+fpundefinstr:	enable_irq r0				@ Enable interrupts
+#ifdef CONFIG_ADEOS_CORE
+		@ undefined instruction -> inform Adeos about it (this is *not* the
+		@ "FPU usage" event because there is no FPU support in Adeos for ARM)
+		mov	r5, lr				@ save lr
+		mov	r0, #4				@ SIGILL
+		mov	r1, sp				@ struct pt_regs *regs
+		bl	__adeos_handle_event
+		cmp	r0, #0
+		bne	ret_from_exception		@ !propagate -> return
+		mov	r0, r5				@ r0 = old lr
+#else /* !CONFIG_ADEOS_CORE */
 		mov	r0, lr
+#endif /* CONFIG_ADEOS_CORE */
 		mov	r1, sp
 		adrsvc	al, lr, ret_from_exception
 		b	SYMBOL_NAME(do_undefinstr)
@@ -901,10 +1040,21 @@ __pabt_usr:	sub	sp, sp, #S_FRAME_SIZE		@
 		ldmia	r4, {r5 - r7}			@ Get USR pc, cpsr
 		stmia	r8, {r5 - r7}			@ Save USR pc, cpsr, old_r0
 		stmdb	r8, {sp, lr}^			@ Save sp_usr lr_usr
+#ifdef CONFIG_ADEOS_CORE
+		@ Earliest point we can enable hw-interrupts because of
+		@ "stmdb ...,{ }^" (it stores the user registers which are
+		@ protected by the disabled irqs).
+		enable_irq ip
+		mov	r0, sp				@ regs
+		bl	SYMBOL_NAME(__adeos_user_exception_save_root)
+#endif /* CONFIG_ADEOS_CORE */
 		alignment_trap r4, r7, __temp_abt
 		zero_fp
-		mov	r0, #MODE_SVC
-		msr	cpsr_c, r0			@ Enable interrupts
+#ifdef CONFIG_ADEOS_CORE
+		@ Interrupts are already enabled.
+#else /* !CONFIG_ADEOS_CORE */
+		enable_irq r0				@ Enable interrupts
+#endif /* CONFIG_ADEOS_CORE */
 		mov	r0, r5				@ address (pc)
 		mov	r1, sp				@ regs
 		bl	SYMBOL_NAME(do_PrefetchAbort)	@ call abort handler
@@ -913,7 +1063,12 @@ __pabt_usr:	sub	sp, sp, #S_FRAME_SIZE		@
  * This is the return code to user mode for abort handlers
  */
 ENTRY(ret_from_exception)
+#ifdef CONFIG_ADEOS_CORE
+		@ hw-irqs should already be enabled, but be paranoid
+		enable_irq r1
+#else /* !CONFIG_ADEOS_CORE */
 		disable_irq r1
+#endif /* CONFIG_ADEOS_CORE */
 		mov	why, #0
 		get_current_task tsk
 		b	ret_to_user
@@ -927,6 +1082,11 @@ ENTRY(fp_enter)
  * r0 = previous, r1 = next, return previous.
  * previous and next are guaranteed not to be the same.
  */
+#ifdef CONFIG_ADEOS_CORE
+/* I think hw-irqs must be disabled on entry to protect spsr_svc from being
+ * modified by an interrupt. (Although I haven't found anything in plain
+ * Linux that guarantees irqs to be disabled ...) */
+#endif
 ENTRY(__switch_to)
 		stmfd	sp!, {r4 - sl, fp, lr}		@ Store most regs on stack
 		mrs	ip, cpsr
@@ -939,6 +1099,34 @@ ENTRY(__switch_to)
 		msr	spsr, ip			@ Save tasks CPSR into SPSR for this return
 		ldmfd	sp!, {r4 - sl, fp, pc}^		@ Load all regs saved previously
 
+#ifdef CONFIG_ADEOS_CORE
+#ifdef CONFIG_ADEOS_THREADS
+/*
+ * Domain switch code. Interrupts must be off on entry.
+ * r0 = incoming domain, r1 = &adp_cpu_current[cpuid]
+ * Contributed by Jerome Poichet <jerome@kingofsofa.org>
+ */
+
+ENTRY(__adeos_switch_domain)
+	stmfd   sp!, {r0 - sl, fp, lr}  @ push most registers onto stack (scratch ip never)
+	mrs     ip, cpsr                @ get current cpsr_SVC and
+	str     ip, [sp, #-4]!          @ push it onto stack
+	mrc     p15, 0, r2, c3, c0      @ get current domain_access_control and
+	str     r2, [sp, #-4]!          @ push it onto stack
+
+	ldr     r2, [r1]                @ r2 = adp_cpu_current[cpuid] (outgoing domain)
+	str     sp, [r2, #4]            @ save outgoing sp_SVC
+	str     r0, [r1]                @ adp_cpu_current[cpuid] = incoming_domain
+	ldr     sp, [r0, #4]            @ load incoming sp_SVC
+
+	ldr     r2, [sp], #4            @ pop previous domain_access_control from stack
+	ldr     ip, [sp], #4            @ pop previous cpsr_SVC from stack
+	mcr     p15, 0, r2, c3, c0      @ restore previous domain_access_control
+	msr     spsr, ip                @ replace current spsr_SVC with previous cpsr_SVC
+	ldmfd   sp!, {r0 - sl, fp, pc}^ @ pop previous registers, pc = previous lr
+#endif /* CONFIG_ADEOS_THREADS */
+#endif /* CONFIG_ADEOS_CORE */
+
 		.section ".text.init",#alloc,#execinstr
 /*
  * Vector stubs.  NOTE that we only align 'vector_IRQ' to a cache line boundary,
@@ -1161,6 +1349,19 @@ __stubs_end:
 
 		.equ	__real_stubs_start, .LCvectors + 0x200
 
+/*
+ * Exception vectors (see ARM Architecture Reference Manual, 2.6 Exceptions)
+ * Vector base is either 0x00000000 or 0xffff0000.
+ *   offset	execption type
+ *   00		reset
+ *   04		undefined instruction
+ *   08		software interrupt
+ *   0C		prefetch abort (instruction fetch memory abort)
+ *   10		data abort (data access memory abort)
+ *   14		address ecxeption (no longer used)
+ *   18		interrupt
+ *   1C		fast interrupt
+ */
 .LCvectors:	swi	SYS_ERROR0
 		b	__real_stubs_start + (vector_undefinstr - __stubs_start)
 		ldr	pc, __real_stubs_start + (.LCvswi - __stubs_start)
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/entry-common.S linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/entry-common.S
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/entry-common.S	2004-07-22 13:48:58.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/entry-common.S	2005-08-12 15:41:58.000000000 -0600
@@ -3,6 +3,9 @@
  *
  *  Copyright (C) 2000 Russell King
  *
+ *  Copyright (C) 2004-2005 Michael Neuhauser, Firmix Software GmbH (mike@firmix.at)
+ *  	Adeos support for EP93xx
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation.
@@ -27,6 +30,57 @@ ENTRY(__do_softirq)
 	bl	do_softirq
 	ldmfd	sp!, {r0 - r3, ip, pc}
 
+#ifdef CONFIG_ADEOS_CORE
+/*
+ * This is how user mode exceptions are handled under Adeos (i.e. when
+ * hw-irqs are enabled, how to return to user mode, etc.):
+ * + ret_from_fork
+ *	enable-irq
+ *	...
+ *	goto ret_disable_irq
+ * + __sys_trace_return
+ *	enable-irq
+ *	...
+ *	goto ret_disable_irq
+ * + vector_swi:
+ *	enable-irq
+ *	if (is-adeos-syscall) {
+ *	    r = adeos_syscall_entry(pt_regs)
+ *	    if (r != 0) { disable_irq; goto adeos_fast_ret }
+ *	    enable-irq
+ *	    goto ret_to_user
+ *	}
+ *	if (__adeos_enter_syscall() != 0) { disable-irq; goto adeos_fast_ret }
+ *	__adeos_user_exception_save_root()
+ *	syscall()
+ *	goto ret_fast_syscall
+ * + __irq_usr (if (was-irq && in-linux-context && !root-ipipe-is-stalled)):
+ *	if (adeos_irq_entry(irq, regs) == 0) restore_user_regs
+ *	enable-irq
+ *	__adeos_user_exception_save_root()
+ *	goto ret_to_user
+ * + __und_usr:
+ *	enable-irq
+ *	__adeos_user_exception_save_root()
+ *	fp-emu()
+ *	if (!fp-was-ok) { enable-irq; if (__adeos_handle_event()) do_undefinstr() }
+ *	goto ret_from_exception
+ * + __dabt_usr:
+ *	enable-irq
+ *	__adeos_user_exception_save_root()
+ *	cpu_data_abort()
+ *	do_DataAbort()
+ *	goto ret_from_exception
+ * + __pabt_usr:
+ *	enable-irq
+ *	__adeos_user_exception_save_root()
+ *	do_PrefetchAbort()
+ *	goto ret_from_exception
+ * + ret_from_exception:
+ * 	enable-irq
+ * 	goto ret_to_user
+ */
+#endif /* CONFIG_ADEOS_CORE */	
 	.align	5
 /*
  * This is the fast syscall return path.  We do as little as
@@ -34,12 +88,32 @@ ENTRY(__do_softirq)
  * stack.
  */
 ret_fast_syscall:
+#ifdef CONFIG_ADEOS_CORE
+	mov	r7, r0				@ save return code
+	bl	__adeos_exit_syscall
+	cmp	r0, #0
+	mov	r0, r7				@ restore return code
+	bne	1f				@ don't propagate (but restore root's ipipe stall flag)
+#else /* !CONFIG_ADEOS_CORE */	
 	disable_irq r1				@ ensure IRQs are disabled
+#endif /* CONFIG_ADEOS_CORE */	
 	ldr	r1, [tsk, #TSK_NEED_RESCHED]
 	ldr	r2, [tsk, #TSK_SIGPENDING]
 	teq	r1, #0				@ need_resched || sigpending
 	teqeq	r2, #0
 	bne	slow
+#ifdef CONFIG_ADEOS_CORE
+1:	@ Entered from ret_fast_syscall if (!need_resched && !sigpending)
+	@ || __adeos_exit_syscall() says do not propagate.
+	@ Restore root's ipipe stall flag.
+	mov	r7, r0				@ save r0
+	add	r0, sp, #S_OFF			@ let r0 point to user regs
+	bl	SYMBOL_NAME(__adeos_ret_to_user_restore_root)
+	@ comes back with hw-irqs disabled
+	mov	r0, r7				@ restore r0
+adeos_fast_ret:
+	@ hw-irqs must be disabled here!
+#endif /* CONFIG_ADEOS_CORE */
 	fast_restore_user_regs
 
 /*
@@ -55,9 +129,11 @@ slow:	str	r0, [sp, #S_R0+S_OFF]!	@ retur
 reschedule:
 	bl	SYMBOL_NAME(schedule)
 ret_disable_irq:
+#ifndef CONFIG_ADEOS_CORE
+	@ We disable irqs just before restoring the registers, not now.
 	disable_irq r1				@ ensure IRQs are disabled
-ENTRY(ret_to_user)
-ret_slow_syscall:
+#endif /* !CONFIG_ADEOS_CORE */
+ENTRY(ret_to_user)				@ return from exception to user-mode
 	ldr	r1, [tsk, #TSK_NEED_RESCHED]
 	ldr	r2, [tsk, #TSK_SIGPENDING]
 	teq	r1, #0				@ need_resched => schedule()
@@ -65,6 +141,12 @@ ret_slow_syscall:
 1:	teq	r2, #0				@ sigpending => do_signal()
 	bne	__do_signal
 restore:
+#ifdef CONFIG_ADEOS_CORE
+	@ Restore root's ipipe stall flag.
+	mov	r0, sp				@ let r0 point to user regs
+	bl	SYMBOL_NAME(__adeos_ret_to_user_restore_root)
+	@ comes back with hw-irqs disabled
+#endif /* CONFIG_ADEOS_CORE */
 	restore_user_regs
 
 __do_signal:
@@ -73,7 +155,9 @@ __do_signal:
 	mov	r1, sp				@ 'regs'
 	mov	r2, why				@ 'syscall'
 	bl	SYMBOL_NAME(do_signal)		@ note the bl above sets lr
+#ifndef CONFIG_ADEOS_CORE
 	disable_irq r1				@ ensure IRQs are disabled
+#endif /* !CONFIG_ADEOS_CORE */
 	b	restore
 
 /*
@@ -82,6 +166,11 @@ __do_signal:
  * calling schedule_tail).
  */
 ENTRY(ret_from_fork)
+#ifdef CONFIG_ADEOS_CORE
+	enable_irq ip				@ should already be enabled, be paranoid
+	@ Note, that the i_bit in the saved cpsr is 0 and the new process
+	@ will be started with an unstalled stage.
+#endif /* CONFIG_ADEOS_CORE */
 	bl	SYMBOL_NAME(schedule_tail)
 	get_current_task tsk
 	ldr	ip, [tsk, #TSK_PTRACE]		@ check for syscall tracing
@@ -143,9 +232,27 @@ ENTRY(vector_swi)
 	str	r4, [sp, #-S_OFF]!		@ push fifth arg
 
 	get_current_task tsk
-	ldr	ip, [tsk, #TSK_PTRACE]		@ check for syscall tracing
 	bic	scno, scno, #0xff000000		@ mask off SWI op-code
+#ifdef CONFIG_ADEOS_CORE
+	ldr	tbl, .adeos_syscall_magic	@ check if it is the Adeos syscall
+	cmp	scno, tbl
+	beq	handle_adeos_syscall
+#endif /* CONFIG_ADEOS_CORE */
 	eor	scno, scno, #OS_NUMBER << 20	@ check OS number
+#ifdef CONFIG_ADEOS_CORE
+	add	r0, sp, #S_OFF			@ let r0 point to user regs
+	mov	r1, scno
+	bl	__adeos_enter_syscall		@ event "enter Linux syscall"
+	cmp     r0, #0				@ r0 == 0 <=> propagate
+	movne	r0, #-EINVAL			@ !propagate -> return EINVAL
+	disable_irq_cond ne			@ !propagate -> disable hw-irqs
+	addeq	tbl, sp, #S_OFF			@ propagate -> tbl = saved user regs
+	bne	adeos_fast_ret			@ !propagate -> fast-return
+	mov	r0, tbl				@ saved regs
+	bl	SYMBOL_NAME(__adeos_user_exception_save_root)
+	ldmia	tbl, {r0-r3}			@ restore syscall args from saved regs
+#endif /* CONFIG_ADEOS_CORE */
+	ldr	ip, [tsk, #TSK_PTRACE]		@ check for syscall tracing
 	adr	tbl, sys_call_table		@ load syscall table pointer
 	tst	ip, #PT_TRACESYS		@ are we tracing syscalls?
 	bne	__sys_trace
@@ -161,6 +268,27 @@ ENTRY(vector_swi)
 	bcs	SYMBOL_NAME(arm_syscall)	
 	b	SYMBOL_NAME(sys_ni_syscall)	@ not private func
 
+#ifdef CONFIG_ADEOS_CORE
+handle_adeos_syscall:
+	@ handle Adeos syscall (used by RTAI for LXRT calls and SRQs)
+	ldr	ip, adeos_syscall_entry
+	add	r0, sp, #S_OFF			@ r0 <- ptr to saved regs
+	mov	lr, pc
+	mov	pc, ip				@ adeos_syscall_entry(pt_regs*)
+	cmp	r0 , #0				@ slow or fast return?
+	@ long long return value is in saved r0/r1, r0 is not loaded from stack
+	@ by fast_restore_user_regs => load it here.
+	ldrne	r0, [sp, #S_R0 + S_OFF]
+	@ r0 != 0 -> fast
+	disable_irq_cond ne
+	bne	adeos_fast_ret
+	@ r0 == 0 -> slow return
+	enable_irq ip
+	add	sp, sp, #S_OFF			@ fix stack-pointer for restore_user_regs
+	mov	why, #0				@ no longer a real syscall
+	b	ret_to_user
+#endif /* CONFIG_ADEOS_CORE */
+
 	/*
 	 * This is the really slow path.  We're going to be doing
 	 * context switches, and waiting for our parent to respond.
@@ -178,6 +306,9 @@ __sys_trace:
 	b	2b
 
 __sys_trace_return:
+#ifdef CONFIG_ADEOS_CORE
+	enable_irq ip				@ should already be enabled, be paranoid
+#endif /* CONFIG_ADEOS_CORE */
 	str	r0, [sp, #S_R0 + S_OFF]!	@ save returned r0
 	mov	r1, sp
 	mov	r0, #1				@ trace exit [IP = 1]
@@ -190,6 +321,15 @@ __sys_trace_return:
 __cr_alignment:
 	.word	SYMBOL_NAME(cr_alignment)
 #endif
+#ifdef CONFIG_ADEOS_CORE
+	@ special syscall to make transition from user-space to kernel-space
+	@ (used by RTAI to implement LXRT calls and SRQs)
+.adeos_syscall_magic:
+	.word	0x9ffff0				@ see asm-arm/rtai_vectors.h
+	.globl SYMBOL_NAME(adeos_syscall_entry)
+SYMBOL_NAME(adeos_syscall_entry):
+	.word	SYMBOL_NAME(__adeos_handle_syscall)	@ Adeos default syscall handler
+#endif /* CONFIG_ADEOS_CORE */
 
 	.type	sys_call_table, #object
 ENTRY(sys_call_table)
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/entry-header.S linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/entry-header.S
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/entry-header.S	2004-07-22 13:48:58.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/entry-header.S	2005-08-12 15:41:58.000000000 -0600
@@ -71,11 +71,12 @@
 
 #ifdef CONFIG_CPU_32
 	.macro	set_cpsr_c, reg, mode
-#if 1
+#if 0
 	/* broken binutils */
 	mov	\reg, \mode
 	msr	cpsr_c, \reg
 #else
+	/* binutils 2.14.90 are OK -- mike@firmix.at */
 	msr	cpsr_c, \mode
 #endif
 	.endm
@@ -88,6 +89,16 @@
 	set_cpsr_c \temp, #MODE_SVC
 	.endm
 
+#ifdef CONFIG_ADEOS_CORE
+	.macro	set_cpsr_c_cond, cond, mode
+	msr\cond cpsr_c, \mode
+	.endm
+
+	.macro	disable_irq_cond, cond
+	set_cpsr_c_cond \cond, #I_BIT | MODE_SVC
+	.endm
+#endif
+
 		.macro	save_user_regs
 		sub	sp, sp, #S_FRAME_SIZE
 		stmia	sp, {r0 - r12}			@ Calling r0 - r12
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/irq.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/irq.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/irq.c	2004-08-03 19:25:38.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/irq.c	2005-08-12 15:41:58.000000000 -0600
@@ -152,6 +152,10 @@ int get_irq_list(char *buf)
 	return p - buf;
 }
 
+#ifdef CONFIG_ADEOS_CORE
+/* increase performance by disabling IRQ lock detection */
+#define check_irq_lock(desc, irq, regs)		(0)
+#else /* !CONFIG_ADEOS_CORE */
 /*
  * IRQ lock detection.
  *
@@ -183,6 +187,7 @@ static int check_irq_lock(struct irqdesc
 	}
 	return 0;
 }
+#endif /* CONFIG_ADEOS_CORE */
 
 static void
 __do_irq(unsigned int irq, struct irqaction *action, struct pt_regs *regs)
@@ -220,6 +225,9 @@ void do_IRQ(int irq, struct pt_regs * re
 	 * Acknowledge and clear the IRQ, but (if its
 	 * a level-based IRQ, don't mask it)
 	 */
+#ifdef CONFIG_ADEOS_CORE
+    if (!adp_pipelined)
+#endif /* CONFIG_ADEOS_CORE */
 	desc->mask_ack(irq);
 
 	/*
@@ -310,6 +318,11 @@ static void do_pending_irqs(struct pt_re
  */
 asmlinkage void asm_do_IRQ(int irq, struct pt_regs *regs)
 {
+#ifdef CONFIG_ADEOS_CORE
+    /* Only fix-up irq if pipline is not active (then it was already done
+     * in __adeos_handle_irq(). <mike@firmix.at> */
+    if (!adp_pipelined)
+#endif /* CONFIG_ADEOS_CORE */
 	irq = fixup_irq(irq);
 
 	/*
@@ -346,6 +359,7 @@ asmlinkage void asm_do_IRQ(int irq, stru
 	return;
 }
 
+#ifndef CONFIG_ADEOS_CORE /* increase performance by disabling IRQ lock detection */
 static void irqlck_timeout(unsigned long _data)
 {
 	struct irqdesc *desc = (struct irqdesc *)_data;
@@ -364,6 +378,7 @@ static void irqlck_timeout(unsigned long
 
 	spin_unlock(&irq_controller_lock);
 }
+#endif /* !CONFIG_ADEOS_CORE */
 
 #ifdef CONFIG_ARCH_ACORN
 void do_ecard_IRQ(int irq, struct pt_regs *regs)
@@ -678,9 +693,11 @@ void __init init_IRQ(void)
 		irq_desc[irq].mask     = dummy_mask_unmask_irq;
 		irq_desc[irq].unmask   = dummy_mask_unmask_irq;
 		INIT_LIST_HEAD(&irq_desc[irq].pend);
+#ifndef CONFIG_ADEOS_CORE /* increase performance by disabling IRQ lock detection */
 		init_timer(&irq_desc[irq].lck_timer);
 		irq_desc[irq].lck_timer.data = (unsigned long)&irq_desc[irq];
 		irq_desc[irq].lck_timer.function = irqlck_timeout;
+#endif /* !CONFIG_ADEOS_CORE */
 	}
 
 	init_arch_irq();
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/Makefile linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/Makefile
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/Makefile	2004-07-22 13:48:58.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/Makefile	2005-08-12 15:41:58.000000000 -0600
@@ -39,7 +39,7 @@ obj-m		:=
 obj-n		:=
 obj-		:=
 
-export-objs	:= armksyms.o dma.o ecard.o fiq.o io.o oldlatches.o time.o
+export-objs	:= adeos.o armksyms.o dma.o ecard.o fiq.o io.o oldlatches.o time.o
 
 no-irq-arch	:= $(CONFIG_ARCH_INTEGRATOR) $(CONFIG_ARCH_CLPS711X) \
 		   $(CONFIG_FOOTBRIDGE) $(CONFIG_ARCH_EBSA110) \
@@ -52,6 +52,7 @@ ifneq ($(findstring y,$(no-irq-arch)),y)
   obj-y		+= irq-arch.o
 endif
 
+obj-$(CONFIG_ADEOS_CORE) += adeos.o
 obj-$(CONFIG_ARCH_ACORN) += ecard.o fiq.o time-acorn.o
 obj-$(CONFIG_ARCH_CLPS7500) += time-acorn.o
 obj-$(CONFIG_ARCH_RISCSTATION) += time-acorn.o
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/process.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/process.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/process.c	2004-07-22 13:48:58.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/process.c	2005-08-12 15:41:58.000000000 -0600
@@ -72,10 +72,22 @@ void (*pm_power_off)(void);
  */
 void default_idle(void)
 {
+#ifdef CONFIG_ADEOS_CORE
+	/* if we don't do a hard cli, we might miss an interrupt and
+	 * sleep for an indefinite time (system lock-up or increased
+	 * interrupt latency) --<mike@firmix@at> */
+	adeos_hw_cli();
+#else
 	local_irq_disable();
+#endif
 	if (!current->need_resched && !hlt_counter)
 		arch_idle();
+#ifdef CONFIG_ADEOS_CORE
+	adeos_hw_sti();
+	ADEOS_PARANOIA_ASSERT(test_bit(IPIPE_STALL_FLAG, &adp_root->cpudata[adeos_processor_id()].status) == 0);
+#else
 	local_irq_enable();
+#endif
 }
 
 /*
@@ -91,12 +103,19 @@ void cpu_idle(void)
 	current->counter = -100;
 
 	while (1) {
+#ifdef CONFIG_ADEOS_CORE
+		adeos_suspend_domain();
+		leds_event(led_idle_start);
+		while (!current->need_resched)
+			default_idle();
+#else /* !CONFIG_ADEOS_CORE */
 		void (*idle)(void) = pm_idle;
 		if (!idle)
 			idle = default_idle;
 		leds_event(led_idle_start);
 		while (!current->need_resched)
 			idle();
+#endif /* CONFIG_ADEOS_CORE */
 		leds_event(led_idle_end);
 		schedule();
 #ifndef CONFIG_NO_PGT_CACHE
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/setup.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/setup.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/setup.c	2004-07-22 13:48:58.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/setup.c	2005-08-12 15:41:58.000000000 -0600
@@ -554,6 +554,20 @@ void __init setup_arch(char **cmdline_p)
 	conswitchp = &dummy_con;
 #endif
 #endif
+
+#if 0
+	/* *DEBUG* initialise ports for debbuging with oscillioscope */
+	/* EGPIO0/A0 */
+	outl(inl(GPIO_AINTEN) & ~1UL, GPIO_AINTEN);	/* no interrupt on A0 */
+	outl(inl(GPIO_AEOI)   |  1UL, GPIO_AEOI);	/* clear interrupt */
+	outl(inl(GPIO_PADDR)  |  1UL, GPIO_PADDR);	/* set to output */
+	outl(inl(GPIO_PADR)   & ~1UL, GPIO_PADR);	/* set value to 0 */
+	/* EGPIO9/B1 */
+	outl(inl(GPIO_BINTEN) & ~2UL, GPIO_BINTEN);      /* disable interrupt */
+	outl(inl(GPIO_BEOI)   |  2UL, GPIO_BEOI);        /* clear interrupt */
+	outl(inl(GPIO_PBDDR)  |  2UL, GPIO_PBDDR);       /* set to output */
+	outl(inl(GPIO_PBDR)   & ~2UL, GPIO_PBDR);        /* set value to 0 */
+#endif
 }
 
 static const char *hwcap_str[] = {
@@ -593,6 +607,23 @@ static int c_show(struct seq_file *m, vo
 	seq_printf(m, "Serial\t\t: %08x%08x\n",
 		   system_serial_high, system_serial_low);
 
+#if 0
+	/* *DEBUG* */
+	static struct { char *n; unsigned long o; } x[] = {
+	    { "IRQSTATUS", VIC0IRQSTATUS},
+	    { "RAWINTR", VIC0RAWINTR},
+	    { "INTENABLE", VIC0INTENABLE},
+	    { "SOFTINT", VIC0SOFTINT},
+	};
+	unsigned long base[2] = {VIC0_BASE, VIC1_BASE};
+	int i, j;
+	for (i = 0; i < 2; ++i) {
+	    for (j = 0; j < 4; ++j) {
+		seq_printf(m, "VIC%d%s\t: %08x\n", i, x[j].n, inl(base[i] + (x[j].o - VIC0_BASE)));
+
+	    }
+	}
+#endif
 	return 0;
 }
 
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/time.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/time.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/time.c	2004-07-22 13:48:58.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/time.c	2005-08-12 15:41:58.000000000 -0600
@@ -224,3 +224,15 @@ void __init time_init(void)
 
 	setup_timer();
 }
+
+#ifdef CONFIG_ADEOS_CORE
+
+/* Simply inline the arch-specific code to set the frequency of the
+   timer. Interrrupts must be masked on entry. */
+
+void __adeos_tune_timer (unsigned long hz) {
+
+    __adeos_set_timer(hz);
+}
+
+#endif /* CONFIG_ADEOS_CORE */
